package com.gtf.factory;

import com.gtf.abstractHanler.GateawayHandler;
import com.gtf.deg.BlacklistHandler;
import com.gtf.dsg.ConversationHandler;
import com.gtf.dyg.CurrentLimitHanler;
import com.gtf.mapper.GatewayHandlerMapper;
import com.gtf.tntity.GatewayHandlerEntity;
import com.gtf.utils.SpringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

@Component
public class FactoryHanlder {
    @Autowired
    private GatewayHandlerMapper gatewayHandlerMap;
    private GateawayHandler firstGatewayHandler;
    public GateawayHandler getDbFirstGatewayHandler() {

        // 1.查询数据库第一个handler配置
        GatewayHandlerEntity firstGatewayHandlerEntity = gatewayHandlerMap.getFirstGatewayHandler();
        if (firstGatewayHandlerEntity == null) {
            return null;
        }
        String firstBeanHandlerId = firstGatewayHandlerEntity.getHandlerId();
        if (StringUtils.isEmpty(firstBeanHandlerId)) {
            return null;
        }
        // 2.从SpringBoot容器获取第一个handler对象
        GateawayHandler firstGatewayHandler = SpringUtils.getBean(firstBeanHandlerId, GateawayHandler.class);
        if (firstGatewayHandler == null) {
            return null;
        }
        // 3. 获取下一个handlerBeanId
        String nextBeanHandlerId = firstGatewayHandlerEntity.getNextHandlerId();
        // 定义临时循环遍历指针
        GateawayHandler tempNextGatewayHandler = firstGatewayHandler;
        while (!StringUtils.isEmpty(nextBeanHandlerId)) {
            // 4.从SpringBoot容器获取下一个handler对象
            GateawayHandler nextGatewayHandler = SpringUtils.getBean(nextBeanHandlerId, GateawayHandler.class);
            if (nextGatewayHandler == null) {
                break;
            }
            // 5.从数据库查询该hanlder信息
            GatewayHandlerEntity nextGatewayHandlerEntity = gatewayHandlerMap.getByHandler(nextBeanHandlerId);
            if (nextGatewayHandlerEntity == null) {
                break;
            }
            // 6.设置下一个white循环遍历hanlderid
            nextBeanHandlerId = nextGatewayHandlerEntity.getNextHandlerId();
            tempNextGatewayHandler.setNextGateawayHandler(nextGatewayHandler);
            tempNextGatewayHandler = nextGatewayHandler;
        }
        this.firstGatewayHandler = firstGatewayHandler;
        return firstGatewayHandler;
    }

}
