package com.gtf.payContextStrategy;

import com.gtf.mapper.PaymentChannelMapper;
import com.gtf.strategy.PayStrategy;
import com.gtf.tntity.PaymentChannelEntity;
import com.gtf.utils.SpringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;
@Component
public class PayContextStrategy {
    @Autowired
     private    PaymentChannelMapper paymentChannelMapper;


    /**
     * 获取具体策略实现
     */
    public  String toPayHtml(String payCode) throws ClassNotFoundException, InstantiationException, IllegalAccessException {
        if (StringUtils.isEmpty(payCode))
            return "null";
        //查询数据库获取具体的实现
        PaymentChannelEntity payCode1 = paymentChannelMapper.getPaymentChannel(payCode);
        if (payCode1 == null) {
            return "没有查询到";
        }
        String strategyBeanId = payCode1.getStrategyBeanId();
        PayStrategy bean = SpringUtils.getBean(strategyBeanId, PayStrategy.class);

        return bean.toPayHtmlt();
    }

}
